'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var postcss = require('postcss');
var rtlcss = require('rtlcss');

var _require = require('./utils.js'),
    getDirRule = _require.getDirRule,
    addDirToSelectors = _require.addDirToSelectors;

module.exports = postcss.plugin('postcss-rtl', function () {
    return function (css) {
        return css.walkRules(function (rule) {
            if (rule.selector.indexOf('[dir') > -1) return;

            var hasSymmetricDecls = false;
            var ltrDecls = [];
            var rtlDecls = [];

            rule.walkDecls(function (decl) {
                var rtlResult = rtlcss.process(decl);
                var isSimmetricDecl = rtlResult === decl.toString();

                var _rtlResult$split = rtlResult.split(/:\s*/),
                    _rtlResult$split2 = _slicedToArray(_rtlResult$split, 2),
                    prop = _rtlResult$split2[0],
                    value = _rtlResult$split2[1];

                hasSymmetricDecls = hasSymmetricDecls || isSimmetricDecl;

                if (!isSimmetricDecl) {
                    ltrDecls.push(decl);
                    rtlDecls.push(decl.clone({ prop: prop, value: value }));
                }
            });

            if (ltrDecls.length) {
                (function () {
                    getDirRule(rule, 'rtl').append(rtlDecls);
                    var ltrDirRule = getDirRule(rule, 'ltr');
                    ltrDecls.forEach(function (_decl) {
                        return _decl.moveTo(ltrDirRule);
                    });
                })();
            }

            if (rule.nodes.length === 0) {
                rule.remove();
            } else {
                rule.selector = addDirToSelectors(rule.selector);
            }
        });
    };
});